/*  "Expressive" compiler
 *
 *  Program for testing the analyzer
 *  Philippe Altherr, Nikolay Mihaylov
 *
 *  $Id: AnalyzerTest.java,v 1.2 2003/03/25 12:13:18 mihaylov Exp $
 */

package expressive;

import java.io.InputStream;
import java.io.PrintWriter;

/**
 * This class tests the type and name analyzer.
 *
 * usage: java expressive.AnalyzerTest <options> [source_file [output-file]]
 * with the following options:
 *   -debug    Print the debug messages
 *   -? -help  Show this help
 */
public class AnalyzerTest extends AbstractMain implements Tokens {

    public void run(Global global, InputStream in, PrintWriter out) {
	Scanner scanner = new Scanner(in);
	Parser parser = new Parser(scanner);
	try {
	    Tree prog = (Tree)parser.parse().value;
	    Analyzer an = new Analyzer(global);
	    an.analyze(prog);
	} catch (Exception e) { e.printStackTrace(); }
    }

    public static void main(String[] args) {
        new AnalyzerTest().run(args);
    }

}
