/*  "Expressive" compiler
 *
 *  Code generator for Expressive programs. Targets the EVM.
 *  Nikolay Mihaylov
 *
 *  $Id: Generator.java,v 1.4 2003/06/03 08:56:45 mihaylov Exp $
 */

package expressive;

import expressive.Tree.*;

import java.io.PrintWriter;

/**
 * Code generator for Expressive programs.
 */
public class Generator implements Visitor, expressive.evm.Instructions {

    //########################################################################
    // Instance variables

    /** The Global instance. */
    final Global global;

    /** The output of the generator. */
    final PrintWriter out;

    /** Generated code. */
    final Code code = new Code();

    //########################################################################
    // Constructors

    public Generator(Global global, PrintWriter out) {
	this.global = global;
	this.out = out;
    }

    //########################################################################
    // Methods

    /** Return a virtual machine with the generated program. */
    public expressive.evm.EVM getVM() {
	return code.getVM();
    }

    /** Generate code for a tree node. */
    public void generate(Tree tree) {
	tree.apply(this);
    }

    /** Generate code for an array of trees. */
    public void generate(Tree[] trees) {
	for (int i = 0; i < trees.length; i++)
	    generate(trees[i]);
    }

    //########################################################################
    // Visitor methods

    public void caseProg(Prog tree) {
	// ...  complter ...
    }

    public void caseIO(IO tree) {
	// ...  complter ...
    }

    public void caseAssign(Assign tree) {
	// ...  complter ...
    }

    public void caseIf(If tree) {
	// ...  complter ...
    }

    public void caseWhile(While tree) {
	// ...  complter ...
    }

    public void caseIdent(Ident tree) {
	// ...  complter ...
    }

    public void caseLiteral(Literal tree) {
	// ...  complter ...
    }

    public void caseOp(Op tree) {
	// ...  complter ...
    }

    //########################################################################
}
