/*  "Expressive" compiler
 *
 *  Opcodes Interface
 *  Nikolay Mihaylov
 *
 *  $Id: OpCodes.java,v 1.1 2003/05/14 14:28:03 mihaylov Exp $
 */

package expressive;

/**
 * Enumerates constants that represent different operations
 * in the Abstract Syntax Tree (AST)
 */
interface OpCodes {

    //########################################################################
    // Constant declarations

    /** '+' */
    int PLUS = 1;

    /** '-' */
    int MINUS = 2;

    /** '*' */
    int TIMES = 3;

    /** '/' */
    int DIV = 4;

    /** '%' */
    int REM = 5;

    /** '^' */
    int POW = 6;

    /** '=' */
    int EQ = 7;

    /** '!=' */
    int NE = 8;

    /** '<' */
    int LT = 9;

    /** '<=' */
    int LE = 10;

    /** '>' */
    int GT = 11;

    /** '>=' */
    int GE = 12;

    /** '|' */
    int OR = 13;

    /** '&' */
    int AND = 14;

    /** '!' */
    int NOT = 15;

    /** 'true' */
    int TRUE = 16;

    /** 'false' */
    int FALSE = 17;

    /** 'print' */
    int PRINT = 18;

    /** 'printnl' */
    int PRINTNL = 19;

    /** 'readint' */
    int READINT = 20;

    /** 'readbool' */
    int READBOOL = 21;

    //########################################################################

}
