/*  "Expressive" compiler
 *
 *  Program to test the pretty printer
 *  Philippe Altherr, Nikolay Mihaylov
 *
 *  $Id: PrinterTest.java,v 1.2 2003/05/21 16:40:44 mihaylov Exp $
 */

package expressive;

import java.io.InputStream;
import java.io.PrintWriter;

/**
 * This class tests the pretty printer. The program reads
 * the source file and prints in the output file the
 * program represented by the abstract syntax tree.
 *
 * usage: java expressive.PrinterTest <options> [source_file [output-file]]
 * with the following options:
 *   -debug    Print the debug messages
 *   -? -help  Show this help
 */
public class PrinterTest extends AbstractMain  {

    public void run(Global global, InputStream in, PrintWriter out) {
	Scanner scanner = new Scanner(in);
	Parser parser = new Parser(scanner);
	try {
	   Tree prog = (Tree)parser.parse().value;
	   Printer printer = new Printer(out);
	   printer.print(prog);
	} catch (Exception e) { e .printStackTrace(); }
    }

    public static void main(String[] args) {
        new PrinterTest().run(args);
    }

}
