/*  "Expressive" compiler
 *
 *  Interface representing the tree visitors
 *  Nikolay Mihaylov
 *
 *  $Id: Visitor.java,v 1.2 2003/03/28 11:36:42 mihaylov Exp $
 */

package expressive;

import expressive.Tree.*;

/**
 * Tree visitors interface
 */
public interface Visitor {
    /** Method that processes Prog nodes. */
    void caseProg(Prog tree);

    /** Method that processes IO nodes. */
    void caseIO(IO tree);

    /** Method that processes Assign nodes. */
    void caseAssign(Assign tree);

    /** Method that processes If nodes. */
    void caseIf(If tree);

    /** Method that processes While nodes. */
    void caseWhile(While tree);

    /** Method that processes Op nodes. */
    void caseOp(Op tree);

    /** Method that processes Ident nodes. */
    void caseIdent(Ident tree);

    /** Method that processes Literal nodes. */
    void caseLiteral(Literal tree);

}
