/*  EVM Assembler
 *
 *  Interface containing additional constants that represent various tokens
 *  
 *  Erik Stenman
 *
 *  $Id: AsmInstructions.java,v 1.2 2003/06/03 09:03:40 mihaylov Exp $
 */

package expressive.evm.asm;

/**
 * Assembler language tokens
 */
public interface AsmInstructions extends expressive.evm.Instructions {

    //########################################################################
    // Constants

    /** Colon (':') - label separator. */
    int COLON = lastinstr + 1;

    /** Integer. */
    int INT = COLON + 1;

    /** Identifier (label)*/
    int IDENT = INT + 1;

    /** String. */
    int STRING = IDENT + 1;

    /** Assembler directive that sets the data memory pool size of the EVM. */
    int MEM_SIZE = STRING + 1;

    /** End Of File token. */
    int EOF = MEM_SIZE + 1;

    //########################################################################
}
