/*  EVM Assembler
 *
 *  Token representation
 *  Erik Stenman
 *
 *  $Id: Token.java,v 1.1 2003/06/02 16:36:38 mihaylov Exp $
 */

package expressive.evm.asm;

/**
 *  Class representing tokens returned by the scanner
 */
public class Token {

    //########################################################################
    // Instance varaibles

    /** The token symbol. */
    public final int sym;

    /** Encoded position of the token in the source file. */
    public final int pos;

    /** Integer value - token INT only. */
    public final int ivalue;

    /** String value - tokens IDENT and STRING. */
    public final String svalue;

    //########################################################################
    // Constructors

    public Token(int sym, int pos) {
	this.sym = sym; this.pos = pos;
	this.ivalue = Integer.MIN_VALUE;
	this.svalue = null;
    }

    public Token(int sym, int pos, int ivalue) {
	this.sym = sym;
	this.pos = pos;
	this.ivalue = ivalue;
	this.svalue = null;
    }

    public Token(int sym, int pos, String svalue) {
	this.sym = sym;
	this.pos = pos;
	this.ivalue = Integer.MIN_VALUE;
	this.svalue = svalue;
    }

    //########################################################################

}
